/*
 *
 *     This file is part of the Squashtest platform.
 *     Copyright (C) 2017 Henix, henix.fr
 *
 *     See the NOTICE file distributed with this work for additional
 *     information regarding copyright ownership.
 *
 *     This is free software: you can redistribute it and/or modify
 *     it under the terms of the GNU Lesser General Public License as published by
 *     the Free Software Foundation, either version 3 of the License, or
 *     (at your option) any later version.
 *
 *     this software is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU Lesser General Public License for more details.
 *
 *     You should have received a copy of the GNU Lesser General Public License
 *     along with this software.  If not, see <http://www.gnu.org/licenses/>.
 */
package org.squashtest.tm.plugin.rest.validators;

import org.springframework.stereotype.Component;
import org.springframework.validation.BeanPropertyBindingResult;
import org.springframework.validation.BindException;
import org.springframework.validation.BindingResult;
import org.springframework.validation.Errors;
import org.springframework.validation.ValidationUtils;
import org.springframework.validation.Validator;
import org.squashtest.tm.domain.requirement.Requirement;
import org.squashtest.tm.domain.requirement.RequirementStatus;
import org.squashtest.tm.domain.requirement.RequirementVersion;
import org.squashtest.tm.domain.testcase.TestCase;
import org.squashtest.tm.plugin.rest.controller.helper.ErrorHandlerHelper;
import org.squashtest.tm.plugin.rest.jackson.model.RequirementVersionDto;
import org.squashtest.tm.plugin.rest.repository.RestRequirementRepository;
import org.squashtest.tm.plugin.rest.repository.RestRequirementVersionRepository;
import org.squashtest.tm.plugin.rest.validators.helper.RequirementVersionDtoValidationHelper;

import javax.inject.Inject;
import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

import static org.squashtest.tm.plugin.rest.jackson.model.RestType.REQUIREMENT_VERSION;
import static org.squashtest.tm.plugin.rest.jackson.model.RestType.TEST_CASE;

@Component
public class RequirementVersionValidator implements Validator {

    private static final String POST_REQUIREMENT_VERSION = "post-requirement-version";
    private static final String PATCH_REQUIREMENT_VERSION = "patch-requirement-version";
    public static final String ASSOCIATE_TEST_CASES = "associate-test-cases";
    public static final String DISASSOCIATE_TEST_CASES = "disassociate-test-cases";



    @Inject
    private RequirementVersionDtoValidationHelper requirementVersionDtoValidationHelper;
    @Inject
    private RestRequirementRepository restRequirementRepository;

    @Inject
    private RestRequirementVersionRepository restRequirementVersionRepository;

    @Override
    public boolean supports(Class<?> clazz) {
        return RequirementVersionDto.class.equals(clazz);
    }

    @Override
    public void validate(Object target, final Errors errors) {

        RequirementVersionDto requirementVersionDto = (RequirementVersionDto) target;

        if (requirementVersionDto.getId() != null) {
            errors.rejectValue("id", "generated value", "This attribute is generated by database and should not be provided. If you want to update an existing requirement version, please do a patch request to the requirement version id. ");
        }

        ValidationUtils.rejectIfEmptyOrWhitespace(errors, "name", "required", "This attribute can't be empty");

        requirementVersionDtoValidationHelper.checkAndAssignValues(errors,requirementVersionDto);


    }

    public void validateRequirementVersion(RequirementVersionDto requirementVersionDto)throws BindException {
        List<Errors> errors = new ArrayList<>();
        BindingResult validation = new BeanPropertyBindingResult(requirementVersionDto, POST_REQUIREMENT_VERSION);

        validate(requirementVersionDto, validation);

        if (validation.hasErrors()) {
            errors.add(validation);
        }
        ErrorHandlerHelper.throwIfError(requirementVersionDto,errors,POST_REQUIREMENT_VERSION);
    }

    public void validatePostRequirementVersion(Long requirementId ) throws BindException {
        List<Errors> errors = new ArrayList<>();
        RequirementVersionDto dummyRequirementVersionDto = new RequirementVersionDto();
        BindingResult validation = new BeanPropertyBindingResult(dummyRequirementVersionDto, POST_REQUIREMENT_VERSION);
        Requirement requirement = restRequirementRepository.getReferenceById(requirementId);

        if(requirement.isSynchronized()){
            validation.rejectValue("requirement","synchronised requirement", "Can not create version for a synchronized requirement");
        }

        if (validation.hasErrors()) {
            errors.add(validation);
        }
        ErrorHandlerHelper.throwIfError(dummyRequirementVersionDto,errors,POST_REQUIREMENT_VERSION);
    }

    public void validatePatchRequirementVersion(RequirementVersionDto requirementVersionDto, Long requirementId ) throws BindException {
        List<Errors> errors = new ArrayList<>();
        BindingResult validation = new BeanPropertyBindingResult(requirementVersionDto, PATCH_REQUIREMENT_VERSION);

        //validate actuel status: if actually status is obsolete ==> error
        Requirement requirement = restRequirementRepository.getReferenceById(requirementId);

        //le idProjet est utilisé pr valider la categorie
        requirementVersionDto.setProjectId(requirement.getProject().getId());

        if(requirement.getStatus().equals(RequirementStatus.OBSOLETE)){
            validation.rejectValue("status","obsolete requirement", "Can not change an obsolete requirement");
        }
        if(requirement.getStatus().equals(RequirementStatus.APPROVED) && !requirementVersionDto.isHasStatus() ){
            validation.rejectValue("status","approved requirement", "Can not change an approved requirement");
        }

        //validate name
        if(requirementVersionDto.isHasName()) {
            ValidationUtils.rejectIfEmptyOrWhitespace(validation, "name", "required", "This attribute can't be empty");
        }
        //validate list categori and initialize status and  criticaly by default value if null ,
        requirementVersionDtoValidationHelper.checkAndAssignValuesPatch(validation,requirementVersionDto, requirement);

        if(requirementVersionDto.isHasCufs()){

            requirementVersionDtoValidationHelper.checkCufs(validation, requirementVersionDto);
        }

        if (validation.hasErrors()) {
            errors.add(validation);
        }
        ErrorHandlerHelper.throwIfError(requirementVersionDto, errors,PATCH_REQUIREMENT_VERSION);

    }

    public void validateAssociateTestCases(long requirementVersionId, List<Long> testCaseIds) throws BindException {
        doValidateVerifyingTestCasesToRequirementVersion(requirementVersionId, testCaseIds, ASSOCIATE_TEST_CASES);
    }

    public void validateDisassociateTestCases(long requirementVersionId, List<Long> testCaseIds) throws BindException {
        doValidateVerifyingTestCasesToRequirementVersion(requirementVersionId, testCaseIds, DISASSOCIATE_TEST_CASES);
    }

    private void doValidateVerifyingTestCasesToRequirementVersion(long requirementVersionId, List<Long> testCaseIds, String errorMessage) throws BindException {
        List<Errors> errors = new ArrayList<>();
        RequirementVersionDto dummyRequirementVersionDto = new RequirementVersionDto();
        BindingResult validationBean = new BeanPropertyBindingResult(dummyRequirementVersionDto, errorMessage);
        requirementVersionDtoValidationHelper.checkEntityExist(validationBean, REQUIREMENT_VERSION, requirementVersionId);
        for (Long id : testCaseIds) {
            requirementVersionDtoValidationHelper.checkEntityExist(validationBean, TEST_CASE, id);

            if(errorMessage.equalsIgnoreCase(ASSOCIATE_TEST_CASES)) {
                checkIfTestCaseIsAleadyBindInAnotherVersion(validationBean, requirementVersionId, id);
            }
        }
        if (validationBean.hasErrors()) {
            errors.add(validationBean);
        }
        ErrorHandlerHelper.throwIfError(dummyRequirementVersionDto, errors, errorMessage);
    }
    private void checkIfTestCaseIsAleadyBindInAnotherVersion(Errors errors, long requirementVersionId, long testCaseId){

        List<Long> allVerifyingTestcaseIds =  getAllVerifyingTestcaseIds(requirementVersionId);

        if (allVerifyingTestcaseIds.contains(testCaseId)){
            String message = String.format("Can not bind the test case %s on this requirement version (id:%d) because is already bind in another version.", testCaseId, requirementVersionId);
            errors.rejectValue("requirement", "invalid test case id", message);
        }


    }
    private List<Long> getAllVerifyingTestcaseIds(long requirementVersionId) {

        RequirementVersion reqVersion = restRequirementVersionRepository.getReferenceById(requirementVersionId);
        List<RequirementVersion> allRequirementVersion = reqVersion.getRequirement().getRequirementVersions();

        return allRequirementVersion.stream()
                .flatMap(sys -> sys.getVerifyingTestCases().stream().map(TestCase::getId))
                .collect(Collectors.toList());
    }
}
